import re
import os
import os.path
from os.path import join 
import time
from tkinter.colorchooser import askcolor
from operator import itemgetter
import random
import webbrowser
import sys
import tempfile

from core_mining_functions import natural_sort, deNoise
import jedli_global
from jedli_global import static_files
import jedli_logger


header = open(join(static_files, "html_header.txt"), mode="r", encoding="UTF-8").read()
footer = open(join(static_files, "html_footer.txt"), mode="r", encoding="UTF-8").read()
shamelapage = '<a href="http://shamela.ws/browse.php/book-{}/page-{}" target="_blank">{}</a>'
shamelabook = '<a href="http://shamela.ws/index.php/book/{}" target="_blank">{}</a>'

juz = "الجزء:"
safha = "الصفحة:"
page_regex = r"%s \w+ ¦ %s \w+" % (juz, safha)

print = jedli_global.print

    
class IndexGenerator:
    def output_or_not(self, array_or_string):
        outputThis = True
        if len(array_or_string) == 0:
            if jedli_global.verbose == False:
                outputThis = False
        return outputThis

    def getContext(self, index_tuple, context, text, text_length): 
        if index_tuple[0] < context:
            a = text[0:index_tuple[1]+context]
        elif index_tuple[1] > text_length - context:
            a = text[index_tuple[0]-context:]
        else:
            a = text[index_tuple[0]-context:index_tuple[1]+context]
        # Trim off the partial words at the beginning and end of the search result:
        if a.count(" ") > 2:
            while a[0] != " ":
                a = a[1:]
            while a[-1] != " ":                
                a = a[:-1]
        return a


    def formatResults(self, context, search_results, regex3):
        outcomes2 = ""
        if context == 0:
            for page_number, x in search_results:
                outcomes2 += "<h1>{}</h1>".format(page_number)
        else:
            for page_number, x in search_results:
                outcomes2 += "<h1>{}:</h1><h1>{}</h1>".format(page_number, x)                            
        outcomes2 = re.sub(regex3, '<span style="background-color: #00ff00">'+r'\1'+'</span>', outcomes2)
        outcomes2 = re.sub(r"\n+\W+\n+", "</br>", outcomes2)
        return outcomes2
    

    def indexGenerator(self, variables, index_context):
        variables.getValues()
        all_words = []
        all_words_regex = []
        for dic in variables.search_values:
            all_words_regex += dic["words_regex"]
            all_words += dic["words"]
        if all_words == []:
            print("You have not selected search terms")
        elif variables.sources == []:
            print("You have not selected source texts")
        else:
            print("Generating your index...")
            context = int(index_context)
            if 0 < context < 3:
                context = (context*5)+5
            else:
                context = context*5

            tmp=tempfile.NamedTemporaryFile(delete=False)
            pth=tmp.name+".html"
            new_file = join(variables.output_folder, "index_"+re.sub("\W+", "", all_words[0])+".html")
            intro = '<div id="intro">Index results</div><div id="index"><br/>'
            final_outcomes = ""
            last_search_time = time.time()
            start = time.time()
            e=0
            for word_regex in all_words_regex:
                print("Currently indexing %s in %s sources..." % (all_words[e], len(variables.sources)))
                
                final_outcomes += '''<div id="intro">Index for the word %s</div><div id="index">
                        <p class="ltr-text">You have searched with this regex: %s</p>''' % (all_words[e], word_regex)
                
                regex3= "(%s)" % word_regex
                c=0
                for element in sorted(variables.sources, key=itemgetter(3)):
                    source = element[2]
                    source_id = os.path.splitext(os.path.basename(element[2]))[0]
                    author = element[0]
                    source_name = element[1]
                    
                    with open(source, mode="r", encoding="utf-8") as source_file:
                        text = source_file.read()
                        text = deNoise(text)
                        L = len(text)
                        all_page_numbers = re.findall(page_regex, text)

                    search_results = []
                    indices = [m.span() for m in re.finditer(word_regex, text)]
                    if self.output_or_not(indices) != False:
                        source_ref = shamelabook.format(source_id, source_name)
                        outcomes = '<p class="ltr-text">The Indexer found %s results in %s - %s</p>' % (len(indices), author, source_ref)
                        for index_tuple in indices:
                            a = self.getContext(index_tuple, context, text, L) 
                            b = text[index_tuple[1]:index_tuple[1]+6000]
                            try:
                                page_number = re.findall(page_regex, b)[0]
                            except:
                                page_number = "[no page number]"
                            if page_number != "[no page number]": # add link to the Shamela page
                                try:
                                    p = all_page_numbers.index(page_number)+1
                                    page_number = shamelapage.format(source_id, p, page_number)
                                except:
                                    continue
                            result = [page_number, a]
                            search_results.append(result)

                        outcomes += self.formatResults(context, search_results, regex3)
                        final_outcomes+= "<br/>"+outcomes+"<br/>"
                    
                    if c%10 == 0:
                        print("    %s sources to go..." % (len(variables.sources)-c))

                        f = open(pth, mode="w", encoding="utf-8")
                        temp = """This is a temporary file, created while the Indexer is still working.
Press F5 to refresh the file with the latest results"""
                        f.write(header+final_outcomes+temp+footer)
                        f.close()
                        if c == 0 and e == 0: # open the temp file if it is not yet open
                            #os.system(new_file)
                            webbrowser.open('file://' + pth)
                            print("""A temporary file is now opening in your browser while the Indexer continues working.
In your browser, press F5 to refresh. The final file will open as soon as the Indexer is finished.""")
                    c+=1

                final_outcomes+= "</div><br/><br/><br/>"
                print("Indexing %s took %s seconds" % (word_regex, (time.time()-last_search_time)))
                last_search_time = time.time()
                e += 1

            end = time.time()
            print("Total indexing time: %s seconds" % (end-start))

            file = open(new_file, mode="w", encoding="UTF-8")
            file.write(header+final_outcomes+footer)
            file.close()
            #os.system(new_file)
            webbrowser.open(new_file)
            print("The final file is now opening in your browser")
        
        

class Highlighter:
    
    def highlighter(self, variables, colorcheck):
        #print(colorcheck)
        variables.getValues()

        default_colors = ["#FFFF00", "#66FF00", "#00CCFF", "#FF0000", "#FF99FF", "#33FFFF",
                          "#FFCC00", "#CC9900", "#CCCCCC", "#999999"]
        hidden_signs = ["$a", "$b", "$c", "$d", "$e", "$f", "$g", "$h", "$i", "$j", "$k", "$l", "$m",
                        "$n", "$o", "$p", "$q", "$r", "$s", "$t", "$u", "$v", "$w", "$x", "$y", "$z"]
        
        checklists = {}
        if colorcheck == 1:
            e=0
            for dic in variables.search_values:
                checklist = dic["words_regex"]
                self.colorpicker(dic)
                checklists[str(self.color[1])] = [checklist, dic["checklist_name"], dic["words"], hidden_signs[e]]
                e+=1
                # this creates dictionary pairs (color: checklist) in checklists
        
        else:
            e=0
            for dic in variables.search_values:                
                checklist = dic["words_regex"]
                if e < len(default_colors):
                    checklists[default_colors[e]] = [checklist, dic["checklist_name"], dic["words"], hidden_signs[e]]                
                    e += 1
                else:
                    # The following function creates a random color taking random hexadecimal
                    # values from 6 to D (not too dark, #not too clear). 0x is the prefix to write
                    # numbers in base-16 in C-based languages
                    color = "#"
                    for number in range(6):
                        color += "%01x" % random.randint(6, 0xD)
                    checklists[color] = [checklist, dic["checklist_name"], dic["words"]] 

        for source in variables.sources:
            text = open(source[2], mode="r", encoding="utf-8").read()
            text = deNoise(text)
            text = re.sub("\n", "<br/>", text)
            text = re.sub("(<br/>){3}", "<br/>", text)
            source_name = source[1]

            start = time.time()
            print("Currently highlighting %s..." % source_name)

            for color in checklists:
                colorcode = color
                for word_regex in checklists[color][0]:
                    word_regex = r"(%s)" % word_regex
                    text = re.sub(word_regex, '<span style="background-color: %s">' % colorcode
                                  +r'\1'+'</span><span class=hidden>%s</span>' %checklists[color][3], text)
            end = time.time()
            print("Timer: %s seconds" % (end-start))

            
            try: 
                short_source_name = "".join(source_name.split()[:2])
            except IndexError:
                short_source_name = source_name
            source_author = source[0]
            html_intro = """<div id="intro"> This html file contains the following source text:<br/><h1>%s - %s</h1><h2>""" % (source_author, source_name)
            source_path_name = re.sub("\s+", "_", source_author+"_"+short_source_name+"_highlighted.html")
            new_file = join(variables.output_folder, source_path_name)
            file = open(new_file, mode="w", encoding="UTF-8")
            file.write(header+'<br/></p><p class="ltr-text">'+html_intro)
            for color in checklists:
                if checklists[color][1] != None:
                    file.write("""Search terms from %s: <br/>highlighted in <span style="background-color: %s">%s</span>
and tagged with this hidden sign: %s<br/><br/>""" % (checklists[color][1], color, color, checklists[color][3]))
                else:
                    file.write("""Search term(s) %s: <br/>highlighted in <span style="background-color: %s">%s</span>
and tagged with this hidden sign: %s<br/><br/>""" % ("-".join(checklists[color][2]), color, color, checklists[color][3]))
            file.write("</h2></div></p><p>"+text+footer)
            file.close()
            print("Your file is now opening in your browser")

            #os.system(new_file)
            webbrowser.open(new_file)

    def colorpicker(self, dic):
        if dic["checklist_name"] is not None:
            head, tail = os.path.split(dic["checklist_name"])
            title_text = "Choose your color for checklist: %s" % tail
        else:
            title_text = "Choose your color for search term(s) %s: " % "-".join(dic["words"])
            
        self.color = askcolor(title = title_text)

class ContextSearch:
    def getContext(self, index_tuple, context, text, text_length): 
        if index_tuple[0] < context:
            a = text[0:index_tuple[1]+context]
        elif index_tuple[1] > text_length - context:
            a = text[index_tuple[0]-context:]
        else:
            a = text[index_tuple[0]-context:index_tuple[1]+context]
##        print("text fragment: ", a)
        return a

    def output_or_not(self, array_or_string):
        outputThis = True
        if len(array_or_string) == 0:
            if jedli_global.verbose == False:
                outputThis = False
        return outputThis

    def contextSearch(self, variables):
        variables.getValues()

        context = int(jedli_global.context_context)
        if 0 < context < 3:
            context = (context*5)+5
        else:
            context = context*5
        print("Conducting the context search...")

        words = variables.search_values[0]["words"]
        words_regex = variables.search_values[0]["words_regex"]
##        print("words_regex:", words_regex)
        AND_words = []
        AND_words_regex = []
        OR_words = []
        NOT_words = []
        NOT_words_regex = []
        for dic in variables.search_values[1:]:
            if dic["and_or_not"] == "AND":
                for element in dic["words_regex"]:
                    AND_words_regex.append(element)
                for element in dic["words"]:
                    AND_words.append(element)
            elif dic["and_or_not"] == "NOT":
                for element in dic["words_regex"]:
                    NOT_words_regex.append(element)
                for element in dic["words"]:
                    NOT_words.append(element)
            else:
                for element in dic["words_regex"]:
                    words_regex.append(element)
                for element in dic["words"]:
                    words.append(element)

        start = time.time()
        last_search_time = 0
        tmp=tempfile.NamedTemporaryFile(delete=False)
        pth=tmp.name+".html"
        outcomes = "</p>"

        if variables.search_values[0]["checklist_name"] is not None:
            checklist_name = variables.search_values[0]["checklist_name"].split("/")[-1].split(".")[0]
            new_file = join(jedli_global.output_folder, checklist_name+"_in_context.html")
        else:
            new_file = join(jedli_global.output_folder, re.sub("\W+", "", words[0])+"_in_context.html")

        i=0
        print(variables.sources[0])
        for element in sorted(variables.sources, key=itemgetter(3)): # sort sources by date
            to_do = len(variables.sources) - i
            print("%s sources to go..." % to_do)
            all_results=[]
            source = element[2]
            source_id = os.path.splitext(os.path.basename(element[2]))[0]
            author = element[0]
            source_name = element[1]
            date = element[3]
            text = open(source, mode="r", encoding="utf-8").read()
            text = deNoise(text)
            L = len(text)
            all_page_numbers = re.findall(page_regex, text)

##            outcomes += """ 
##<div id="intro" class="block">
##Context results for:
##{}  -  {}</h1>
##File path: {}
##<br/>
##</div>""".format(author, source_name, source)

            e=0
            current_outcomes = ""
            for word in words:
                print("Currently processing %s in %s..." % (word, os.path.basename(source)))
                search_results = []
                word_regex = words_regex[e]

                indices = [m.span() for m in re.finditer(word_regex, text)]
               
                for index_tuple in indices:
                    a = self.getContext(index_tuple, context, text, L)
                    # Trim off the partial words at the beginning and end of the search result:
                    if a.count(" ") > 2:
                        while a[0] != " ":
                            a = a[1:]
                        while a[-1] != " ":                
                            a = a[:-1]

                    b = text[index_tuple[1]:index_tuple[1]+6000]
                    try:
                        page_number = re.findall(page_regex, b)[0]
                    except:
                        page_number = "[no page number]"
                    if page_number != "[no page number]": # add link to the Shamela page
                        try:
                            p = all_page_numbers.index(page_number)+1
                            page_number = shamelapage.format(source_id, p, page_number)
                        except:
                            continue
                    result = [page_number, a, index_tuple]
                    search_results.append(result)
##                print("search_results", search_results)
                #print("Timer: %s seconds" % (time.time()-start))
                print("took %s seconds" % (time.time() - last_search_time))
                last_search_time = time.time()
                
##                if self.output_or_not(search_results) == True:
##                    current_outcomes += "<br/></p><p class=ltr-text>Number of times %s is \
##                                    mentioned in the text: %s<br/>" % (word, len(search_results))                    
##                print(1, search_results)

                limited_results = []
                if AND_words != []:
                    for x in search_results:
                        f=0
                        for term in AND_words:
                            term = AND_words_regex[f]
                            term_in_x = re.findall(term, x[1])
                            if len(term_in_x)>0:
                                limited_results.append(x)
                                # for every search word that is in the search results,
                                # a result will be in limited_results
                            f+=1
                else:
                    limited_results = search_results
##                print(2, limited_results)

                desired_contexts=[]
                for x in limited_results:
                    if x not in desired_contexts:
                        desired_contexts.append(x)
##                if self.output_or_not(desired_contexts) == True:
##                    current_outcomes += "Number of times it is mentioned in likely desired contexts: %s<br/>" % len(desired_contexts)
        
                deleted_results=[]
                
                if NOT_words != []:
                    for element in limited_results:
                        g=0
                        for term in NOT_words:
                            term = NOT_words_regex[g]
                            term_in_results = re.findall(term, element[1])
                            if len(term_in_results)>0:
                                if 0 < limited_results.count(element) < 2:
                                    deleted_results.append(element)
                                    limited_results.remove(element)
        
                                else:
                                    continue
                            else:
                                pass
                        g+=1


                final_results = []         
                for element in limited_results:
                    if element not in final_results:
                        final_results.append(element)
                
                if self.output_or_not(final_results) == True:
                    current_outcomes += "<br/></p><p class=ltr-text>Number of times %s is \
                                    mentioned in the text: %s<br/>" % (word, len(search_results))                       
                    current_outcomes += "Number of times it is mentioned in likely desired contexts: %s<br/>" % len(desired_contexts)                    
                    current_outcomes += "Number of times it is mentioned in desired context after \
                                removal of undesired contexts: %s</p><p>" % len(final_results)

                all_results+=final_results
                e+=1
                all_results = natural_sort(all_results, itemgetter(0))

                if self.output_or_not(all_results) == True:
                    output_context = jedli_global.output_context
                    for page_number, fragment, index_tuple in all_results:
                        if context != output_context:
                            fragment = self.getContext(index_tuple, context+output_context, text, L)
                        #if word in fragment:
                        if re.findall(word_regex, fragment) != []:
                            output = page_number+"<br/>"+fragment+"<br/>"
                            current_outcomes += str(output)+"<br/>"
                    current_outcomes += "<br/><br/>"
                    for term in AND_words_regex:
                        regex = r"(%s)" % term
                        current_outcomes = re.sub(regex, '<span style="background-color: #FFFF00">'+r'\1'+'</span><span class=hidden>$a</span>', current_outcomes)
                    for term in words_regex:
                        regex = r"(%s)" % term
                        current_outcomes = re.sub(regex, '<span style="background-color: #00FF00">'+r'\1'+'</span><span class=hidden>$b</span>', current_outcomes)

            if self.output_or_not(current_outcomes) == True:
                source_id = os.path.splitext(os.path.basename(source))[0]
                source_ref = shamelabook.format(source_id, source_name)
                outcomes += """ 
<div id="intro" class="block">
Context results for:
<br/>{}  -  {}</h1>
<br/>
</div>""".format(author, source_ref)

                outcomes += current_outcomes
                

            if len(variables.sources) == 1:
                continue
            elif len(variables.sources) == i:
                continue
            else:
##                tmp=tempfile.NamedTemporaryFile(delete=False)
##                pth=tmp.name+".html"
                f = open(pth, mode="w", encoding="utf-8")
                temp = """This is a temporary file, created while the Context Search is still working.
Press F5 to refresh the file with the latest results"""
                f.write(header+outcomes+temp+footer)
                f.close()
                if i == 0:
                    #os.system(new_file)
                    webbrowser.open('file://' + pth)
                    print("""A temporary file is now opening in your browser while the Context Search continues working.
In your browser, press F5 to refresh. The final file will open as soon as the Context Search is finished.""")
                i += 1


        end = time.time()
        print("Indexing time: %s seconds" %(end-start))

        file = open(new_file, mode="w", encoding="UTF-8")
        file.write(header+outcomes+footer)
        file.close()        
        #os.system(new_file)
        webbrowser.open(new_file)
        print("The final file is now opening in your browser")


